(

// algo001t2 v0.05 131102
// Really basic - SinOsc and a mixture of tones
// Uses case and collections of arpeggiated triads
// Uses SCNumberBox
// Prohibits values lower than 0.01;
// 091031: even simpler, uses a task.
// Uses a mixture of voices

var w;
var mainBut, mainButState = 1;
var myTime = 0.1, timeBox, randTime;
var stream;
var pitch, count = 0;
var myArray = [ 60, 62, 63, 65, 67 ];

w = Window("SC Algorithm GUI Tutor 001a", Rect(20, 800, 240, 100));

// Synth to play it: in this case it's a basic sine wave.  You can experiment with others...
s = Server.local;

// Let's use a different synth for a change.  Feel free to investigate it, alter it, or choose something else.

(
SynthDef("MyBlip", {
	arg pitch=69, nharm=4, amp=0.05, decay=1;
	var snd, env, pos, wobble, freq;
	freq = pitch.midicps;
	wobble = LFNoise1.kr(Rand(2, 5), freq * 0.0025, freq * 0.0025);
	snd = Blip.ar(freq + wobble, nharm);
	env = EnvGen.kr(Env.perc(releaseTime:decay), doneAction:2);
	pos = Line.kr(-1, 1, decay);
	Out.ar(0, Pan2.ar(snd * env, Rand(-1, 1), amp));
}).send(s);
);

SynthDef( "Algorithmic", { arg freq;
	var out;

	out = SinOsc.ar( freq, 0, mul: EnvGen.kr( Env.perc(0.001, 0.2, 1.0, -4), levelScale: 0.1, doneAction: 2 ));

	Out.ar( 0, out );
}).send(s);

// here's the stream...

stream = Task({
	loop({
			while ( { count < myArray.size },
				{
					pitch = myArray[count];
					pitch.postln;
					if ( 0.5.coin,
						{ Synth( "Algorithmic", [ \freq, pitch.midicps ] ); } ,
						{ Synth( "MyBlip", [ \pitch, pitch, \nharm, [2,3,4,5,6,7,8].choose ] ); }
					);
					myTime.wait;
					count = count + 1;
				});
			count = 0
	});
});

// look at the other examples, but also:
// choose, if, while, for, forBy, do, switch, case
// see control structures, and think up some uses for them



// The static text for the word 'speed'


a = StaticText(w, Rect(130, 20, 40, 20));
a.font_(Font("Helvetica", 12));
a.string = "speed";



timeBox = NumberBox(w, Rect(130, 40, 60, 20));
		timeBox.clipLo = 0.01;
		timeBox.value = 0.1;
		timeBox.scroll_step = 0.01;
		timeBox.action = ({ arg v;
			myTime = v.value;
		});

// The static text for the word 'seconds'


a = StaticText(w, Rect(200, 40, 40, 20));
a.font_(Font("Helvetica", 12));
a.string = "secs";




mainBut = Button(w, Rect(20,40,100,20))


		.states_([["Play"],["Stop"]])
		.action_({ arg butt;
			mainButState = mainBut.value;



			if ( mainButState == 1 , // this is if the button is on!
							{ stream.reset; stream.play }, // do this
							{ stream.stop } // otherwise do this.
			);



		}); // end of action
w.front;
)
