(
// algo005
// v091004
// Includes one number box to control pitch

var w;
var mainBut, mainButState;
var myTime = 0.1, timeBox, randTime;
var allPassBox, allPassVal = 0.1;
var pitchBox, myPitch = 60;
var stream;

w = Window("SC Algorithm GUI Tutor 005", Rect(20, 500, 300, 120));

// The static text for the word 'speed'
a = StaticText(w, Rect(130, 20, 40, 20));
a.font_(Font("Helvetica", 12));
a.string = "speed";


// timeBox defines variable myTime


timeBox = NumberBox(w, Rect(170, 20, 60, 20));
		timeBox.clipLo = 0.02;
		timeBox.scroll_step = 0.01;
		timeBox.value = 0.1;
		timeBox.action = ({ arg tb;
			myTime = tb.value;
		});


// The static text for the word 'allpass'
a = StaticText(w, Rect(20, 50, 40, 20));
a.font_(Font("Helvetica", 12));
a.string = "allpass";



// defines value of all pass filter in synthDef
allPassBox = NumberBox(w, Rect(65, 50, 60, 20));
		allPassBox.clipLo = 0.01;
		allPassBox.scroll_step = 0.01;
		allPassBox.value = 0.1;
		allPassBox.action = ({ arg tb;
			allPassVal = tb.value;
		});



// The static text for the word 'pitch'
a = StaticText(w, Rect(20, 80, 40, 20));
a.font_(Font("Helvetica", 12));
a.string = "pitch";



// defines pitch
pitchBox = NumberBox(w, Rect(65, 80, 34, 20))
		.value_(60)
		.scroll_step_(1)
		.clipLo_(0)
		.clipHi_(127)
		.background_(Color.blue(0.0,0.1))
		.action_({ arg mp;
			myPitch = mp.value;
		});


// Synth to play it (from Streams...)

s = Server.local;


SynthDef( "Help-SPE1", { arg i_out=0, freq, allPassVal;
	var out;
	out = RLPF.ar(
		LFSaw.ar( freq, mul: EnvGen.kr( Env.perc, levelScale: 0.3, doneAction: 2 )),
		LFNoise1.kr(1, 36, 110).midicps,
		0.1
	);
	out = [out, DelayN.ar(out, allPassVal, allPassVal) ];
	// 4.do({ out = AllpassN.ar(out, 0.05, [allPassVal.rand, allPassVal.rand], 4) });
	Out.ar( i_out, out );
}).send(s);



// here's the stream...

stream = Routine.new({
	loop({
			myPitch.yield;
		});
});



mainBut = Button(w, Rect(20,20,100,20))
		.states_([["Play"],["Stop"]])
		.action_({ arg butt;
			butt.value.postln;
			mainButState = mainBut.value;

					fork {
						while ( { mainButState == 1 }, // this is if the button is on!
							{
									1.do({

									Synth( "Help-SPE1", [ \freq, stream.next.midicps, \allPassVal, allPassVal ] );
									myTime.wait; // synonym for yield, used by .play to schedule next occurence
									})

						} ) // end while
					}; // end fork


		}); // end of action
w.front;
)
