(

// algo006 v002 131102
// Includes a series of boxes to control pitch, and a box to control how many of those boxes to control.

var w;
var mainBut, mainButState;
var myTime = 0.2, timeBox, randTime;
var allPassBox, allPassVal = 0.1;
var pPatArray, pPatNB, pPatNum = 6;
var pPatNumNB;
var stream;

w = Window("SC Algorithm GUI Tutor 006", Rect(20, 800, 500, 200));

// The static text for the word 'speed'
a = StaticText(w, Rect(130, 20, 40, 20));
a.font_(Font("Helvetica", 12));
a.string = "speed";


// timeBox defines variable myTime
timeBox = NumberBox(w, Rect(170, 20, 60, 20));
		timeBox.clipLo = 0.02;
		timeBox.scroll_step = 0.01;
		timeBox.value = 0.1;
		timeBox.action = ({ arg tb;
			myTime = tb.value;
		});

// The static text for the word 'allpass'
a = StaticText(w, Rect(20, 50, 40, 20));
a.font_(Font("Helvetica", 12));
a.string = "allpass";



// defines value of all pass filter in synthDef
allPassBox = NumberBox(w, Rect(65, 50, 60, 20));
		allPassBox.clipLo = 0.01;
		allPassBox.scroll_step = 0.01;
		allPassBox.value = 0.1;
		allPassBox.action = ({ arg tb;
			allPassVal = tb.value;
		});

// The static text for the word 'pitch'
a = StaticText(w, Rect(20, 80, 40, 20));
a.font_(Font("Helvetica", 12));
a.string = "pitch";



pPatNumNB = NumberBox(w, Rect(65, 80, 30, 20))
		.value_(6)
		.scroll_step_(1)
		.clipLo_(1) // in effect, this is the number of pitch boxes.
		.clipHi_(6) // less than one and higher than six would crash.
		.background_(Color.blue(0.0,0.1))
		.action_({ arg mp;
			pPatNum = mp.value;
		});



// Array for the pattern numbers...
pPatArray = Array.fill(pPatNum);
pPatNum.do({ |a| pPatArray[a] = 0 });

pPatArray[0] = 36;
pPatArray[1] = 43;
pPatArray[2] = 48;
pPatArray[3] = 55;
pPatArray[4] = 60;
pPatArray[5] = 67;




// make this a routine...
(


pPatNB = Array.fill(pPatNum, { arg i;
	NumberBox.new(w, Rect(20 + (38*i), 120, 34, 25))
		.font_(Font("Helvetica", 12))
		.value_(30).step_(1).clipLo_(0).clipHi_(127)
		.scroll_step_(1.0)
		.clipLo_(0)
		.action_({ arg v;
			pPatNB[i].value = v.value;
			pPatArray[i] = v.value;
		})
	});
);

pPatNB[0].value = 36;
pPatNB[1].value = 43;
pPatNB[2].value = 48;
pPatNB[3].value = 55;
pPatNB[4].value = 60;
pPatNB[5].value = 67;


// Synth to play it (from Streams...)

s = Server.local;

SynthDef( "Help-SPE1", { arg i_out=0, freq, allPassVal;
	var out;
	out = RLPF.ar(
		LFSaw.ar( freq, mul: EnvGen.kr( Env.perc, levelScale: 0.3, doneAction: 2 )),
		LFNoise1.kr(1, 36, 110).midicps,
		0.1
	);
	//out = [out, DelayN.ar(out, 0.04, 0.04) ];
	4.do({ out = AllpassN.ar(out, 0.05, [allPassVal, allPassVal], 4) });
	Out.ar( i_out, out );
}).send(s);



// here's the stream...
stream = Routine.new({
	loop({
			pPatNum.do({ |a| pPatArray[a].yield });
		});
});



mainBut = Button(w, Rect(20,20,100,20))
		.states_([["Play"],["Stop"]])
		.action_({ arg butt;
			butt.value.postln;
			mainButState = mainBut.value;

					fork {
						while ( { mainButState == 1 }, // this is if the button is on!
							{
									1.do({
									// Routine( "stream", [ \pPatVal, pPatVal ] );


									Synth( "Help-SPE1", [ \freq, stream.next.midicps, \allPassVal, allPassVal ] );
									myTime.wait; // synonym for yield, used by .play to schedule next occurence
									})


						} ) // end while
					}; // end fork

		}); // end of action
w.front;
)
