// Rising Sines
// from Cottle 2013

s.boot;


(
{
	CombN.ar( // Delay Ugen
		SinOsc.ar( // Sine Osc Ugen provides input for delay
			LFNoise1.kr( // Step Noise Ugen provides freq for Sine
				4, // LFO of step noise, for "wandering"
				24, // range in MIDI of step noise wandering
				LFSaw.kr(
					[8,7.23], //second LFO for "sweep" 0,
					3, // range in MIDI of sweep
					80 // offset in MIDI of sweep
				)
			).midicps,
			0,
			0.04 ),
		0.2, // max delay
		0.2, // actual delay
		4 // delay decay
) }.play )


//
// if necessary:
b = Buffer.loadDialog;

14.7:: 60 Second Phase

(
{
	var mix, loop, duration;
	duration = [1, 61/60]; // duration in seconds of the loop
	loop = Impulse.kr(1/duration); // duration converted to frequency
	mix = PlayBuf.ar(1, b, 1, loop, rrand(0, b.numFrames));
	mix = mix * EnvGen.kr(Env.linen(0.1, 0.8, 0.1), loop, timeScale: duration);
	mix;
}.play;
)


14.8:: Generative Choices


(
{
	var mix, loop, duration, rate, gen, start;
	gen = Impulse.kr(1/15); // every 15 seconds
	// choose another speed and direction at each gen trigger
	rate = TRand.kr(-2.0, 2.0, gen); // Choose values between -2 and 2
	start = TIRand.kr(0, b.numFrames, gen); // start location
	duration = [1, 15/16]; // match the gen trigger; could I use a variable?
	loop = Impulse.kr(1/duration); // duration converted to frequency
	mix = PlayBuf.ar(1, b, rate, loop, start);
	mix = mix * EnvGen.kr(Env.linen(0.1, 0.8, 0.1), loop, 1, 1, duration);
	mix;
}.play;
)


(
{ // Be patient; change happens gradually.
	var mix, loop, duration, rate, gen, start, baseloop, buffer;
	gen = Impulse.kr(1/20); // every 20 seconds
	baseloop = TRand.kr(0.5, 3.0, gen); // select a base loop time // choose another speed and direction at each gen trigger
	rate = TRand.kr(-2.0, 2.0, gen);
	start = TIRand.kr(0, b.numFrames, gen);
	duration = [baseloop, baseloop * TChoose.kr(gen, [3/2, 4/3, 5/4, 6/5])]; loop = Impulse.kr(1/duration); // duration converted to frequency
	mix = PlayBuf.ar(1, b, rate, loop, start);
	mix = mix * EnvGen.kr(Env.linen(0.1, 0.8, 0.1), loop, 1, 1, duration);
	mix;
}.play; )

// Load a new buffer on the fly
b = Buffer.loadDialog(bufnum: b.bufnum);
// This will switch you over to the sclang interpreter.
// To continue editing, or stop the sound, switch back to SuperCollider


////////////////

15.1:: Keyboard Triggers
( {
	SinOsc.ar( LFNoise0.kr(
		TRand.kr(4, 12, KeyState.kr(123)), // Left arrow triggers new rate mul: 6,
		// Right arrow triggers new octave
		add: TIRand.kr(4, 8, KeyState.kr(124))*12).midicps)
}.play )


// If beginning from scratch //
b = Buffer.loadDialog;
( {
	var mix, loop, duration, rate, start, baseloop, buffer;
	baseloop = TRand.kr(0.5, 3.0, KeyState.kr(125)); // Down arrow, new loop
	rate = TRand.kr(-2.0, 2.0, KeyState.kr(123)); // Left arrow, new speed

	start = TIRand.kr(0, b.numFrames, KeyState.kr(124)); // Right arrow, new start
	duration = [baseloop, baseloop * TChoose.kr(KeyState.kr(125), [3/2, 4/3, 5/4, 6/5])];
	loop = Impulse.kr(1/duration);
	mix = PlayBuf.ar(1, b, rate, loop, start);
	mix = mix * EnvGen.kr(Env.linen(0.1, 0.8, 0.1), loop, timeScale: duration);
	mix;
}.play; )
